;
; x[KJ[gbWĂ݃vO
;
	relaxed on

USERAM	equ	$40	; RAMgp
USEROM	equ	$00	; RAMgp
IOMEMA	port	$30	; BankAi0x0000-0x1FFF)
IOMEMB	port	$31	; BankBi0x2000-0x3FFF)
IOMEME	port	$34	; BankEi0x8000-0x9FFF)
IOMEMF	port	$35	; BankFi0xA000-0xBFFF)
IO6001	port	$06	; @ݒ

FM555	equ	$8555	; FLASH-ROMpAhXp^[
FM2AA	equ	$82aa	; FLASH-ROMpAhXp^[

	org	$e500

JPTBL:
	jp	NOERR		; 0xE500
	jp	RDFD		; 0xE503
	jp	FMW8KB		; 0xE506
	jp	SECERASE	; 0xE509

	org	$e530

ERRNUM:	db	$00	; OȊO̎AG[
DTNUM:	db	$00	; tbVf[^ԍi0x00-0x10j
PATXOR:	db	$00	; _p^[XORl



; *******************************
; ݒ
; *******************************
INIT:
	di

	ld	a,$a1		; 0x0000-0x5FFF:BASIC-ROMA0x6000-0x7FFF:OROM
	out	($f0),a		; ǂݏoݒ
	ld	a,$de		; 0x8000-0xBFFF:ORAMA0xC000-0xFFFF:RAM
	out	($f1),a		; ǂݏoݒ
	ld	a,$65		; 0x8000-0xBFFF:ORAMAȊO:RAM
	out	($f2),a		; ݐݒ

	xor	a
	out	IO6001,a	; @ݒ͂Ȃ

	ld	a,USEROM|0
	out	IOMEME,a	; 0x8000-0x9FFF:ROMݒ
	ld	a,USERAM|5
	out	IOMEMF,a	; 0xA000-0xBFFF:RAMݒioN#5j

	ei
	ret


; *******************************
; G[Ȃ
; *******************************
NOERR:
	call	INIT
	xor	a
	ld	(ERRNUM),a
	ret


; *******************************
; G[
; *******************************
ILLERR:
.pop2:	pop	hl		; push߂
.pop1:	pop	hl		; push߂
.pop0:	call	INIT
	ld	a,$ff
	ld	(ERRNUM),a
	ei
	ret


; *******************************
; tbs[tbVf[^ǂݏo
; *******************************
RDFD:
	ld	a,(DTNUM)

		; gbNԍZo
	add	a,a
	add	a,2		; ItZbg

	ld	b,a		; gbNԍ
		; t@Cǂݍ
	xor	a
	ld	(ix+0),a	; hCuԍ
	ld	(ix+27),a	; G[JE^
	ld	de,$a000
.lp2:	ld	c,$01		; ǂݏoJnZN^ԍ
.lp1:	push	bc
	push	de
	ld	a,$01		; ǂݏoZN^
	or	a		; Cflag=0,Zflag=0
	call	$4274
	jp	c,ILLERR.pop2
	pop	de
	pop	bc
	inc	d
	inc	c		; ZN^ԍ++
	ld	a,c
	cp	$11
	jr	nz,.lp1
	inc	b		; gbNԍ++
	ld	a,d
	cp	$c0
	jr	nz,.lp2

	jp	NOERR


; *******************************
; FLASH̃ZN^
; *******************************
SECERASE:
	di

	ld	a,(DTNUM)
	and	$07
	cp	$02
	jp	c,ILLERR.pop0
	add	a,a
	add	a,a
	add	a,a		; x8
	or	USEROM
	out	IOMEME,a
	ld	hl,$8000
	ld	a,(hl)		; 0xFFA0x00ɂ
	inc	a
	jr	nz,.next01

	xor	a
	call	FMW1B
	jp	nz,ILLERR.pop0

.next01:
	ld	hl,$9fff
	ld	a,(hl)		; 0xFFA0x00ɂ
	inc	a
	jr	nz,.next02

	xor	a
	call	FMW1B
	jp	nz,ILLERR.pop0

.next02:
	ld	hl,$8000
	ld	a,$aa
	ld	(FM555),a
	ld	a,$55
	ld	(FM2AA),a
	ld	a,$80
	ld	(FM555),a
	ld	a,$aa
	ld	(FM555),a
	ld	a,$55
	ld	(FM2AA),a
	ld	a,$30
	ld	(hl),a


	ld	b,5

		;
		; 2b炢҂
		;
.L01:	ld	hl,1000

.W01:	ld	a,$78
.W02:	dec	a		; 5
	jr	nz,.W02		; 13 : v 18

	dec	hl
	ld	a,h
	or	l
	jr	nz,.W01

		;
		; Data Check
		;
	ld	hl,$8000

	ld	a,($8000+$1FFF)	; eraseA0xFF
	and	(hl)		; eraseA0xFF
	inc	a

	jp	z,NOERR
	djnz	.L01

	jp	ILLERR.pop0



; *******************************
; FLASH-ROMɂPoCg
; i8KoCgނ̃Tu[`j
; AregFރf[^
; HL:ރAhX
;
; RETURN : Zflag=0AG[
; *******************************
FMW1B:
	cp	$ff
	ret	z		; FFHȂ珑ݕsv

	ld	c,a
	ld	a,$aa
	ld	(FM555),a
	ld	a,$55
	ld	(FM2AA),a
	ld	a,$a0
	ld	(FM555),a
	ld	(hl),c

		;
		; 200 us炢҂
		;
	ld	a,$0a
.W00:	dec	a		; 5
	jr	nz,.W00		; 13 : v 18

	; Verify
	ld	a,(hl)
	xor	c
	ret


; *******************************
; FLASH-ROM8KoCg
; *******************************
FMW8KB:
	ld	a,(DTNUM)
	and	$3f
	cp	$10
	jp	c,ILLERR.pop0

	or	USEROM
	out	IOMEME,a

	di

	ld	hl,$8000
	ld	de,$a000

.lp1:
	ld	a,(de)
	call	FMW1B
	jp	nz,ILLERR.pop0
	inc	hl
	inc	de
	ld	a,d
	cp	$c0
	jr	nz,.lp1

	jp	NOERR


end
